﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.Collections.ObjectModel;

namespace ImageViewerSample
{
	public partial class MainPage : PhoneApplicationPage
	{
		public class DataContextObject
		{
			public string Title { get; set; }
			public Uri ImageUri { get; set; }
			public Uri ThumbnailUri { get; set; }
		}

		public MainPage()
		{
			InitializeComponent();
			CreateData();
		}

		private void CreateData()
		{
			ObservableCollection<DataContextObject> data = new ObservableCollection<DataContextObject>();

			data.Add(new DataContextObject()
			{
				ThumbnailUri = new Uri("http://farm4.staticflickr.com/3572/3396526424_de5aa0b73f_t.jpg", UriKind.Absolute),
				ImageUri = new Uri("http://farm4.staticflickr.com/3572/3396526424_de5aa0b73f_b.jpg", UriKind.Absolute),
				Title = "Redlands Classic Bike race"
			});
			data.Add(new DataContextObject()
			{
				ThumbnailUri = new Uri("http://farm4.staticflickr.com/3509/3909187130_401d576df6_t.jpg", UriKind.Absolute),
				ImageUri = new Uri("http://farm4.staticflickr.com/3509/3909187130_401d576df6_b.jpg", UriKind.Absolute),
				Title = "Aliens!"
			});
			this.DataContext = data;

			data.Add(new DataContextObject()
			{
				ThumbnailUri = new Uri("http://farm4.staticflickr.com/3247/2751012995_ea5d8e76ef_t.jpg", UriKind.Absolute),
				ImageUri = new Uri("http://farm4.staticflickr.com/3247/2751012995_ea5d8e76ef_b.jpg", UriKind.Absolute),
				Title = "The secret to how I get stuff done"
			});

			data.Add(new DataContextObject()
			{
				ThumbnailUri = new Uri("http://farm4.staticflickr.com/3074/2751014785_4516b9cbb1_t.jpg", UriKind.Absolute),
				ImageUri = new Uri("http://farm4.staticflickr.com/3074/2751014785_4516b9cbb1_b.jpg", UriKind.Absolute),
				Title = "I am my own rock band!"
			});
		}

		private void ListBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
		{
			var data = (sender as ListBox).SelectedItem as DataContextObject;
			if (data != null)
			{
				(sender as ListBox).SelectedItem = null;
				NavigationService.Navigate(new Uri(string.Format("/ViewImagePage.xaml?ImageUri={0}&ThumbUri={1}",
					Uri.EscapeDataString(data.ImageUri.OriginalString), Uri.EscapeDataString(data.ThumbnailUri.OriginalString)),
					UriKind.Relative));
			}
		}

		private void searchBox_TextChanged(object sender, TextChangedEventArgs e)
		{
			
		}
	}
}