﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;

namespace ImageViewerSample
{
	public partial class ViewImagePage : PhoneApplicationPage
	{
		public class DataContextObject
		{
			public Uri ImageUri { get; set; }
			public Uri ThumbnailUri { get; set; }
		}

		public ViewImagePage()
		{
			InitializeComponent();
		}

		protected override void OnNavigatedTo(System.Windows.Navigation.NavigationEventArgs e)
		{
			base.OnNavigatedTo(e);
			string url = null;
			string thumburl = null;
			if(NavigationContext.QueryString.ContainsKey("ImageUri"))
				url = NavigationContext.QueryString["ImageUri"];
			var datacontext = new DataContextObject();
			if (!string.IsNullOrEmpty(url))
				datacontext.ImageUri = new Uri(Uri.UnescapeDataString(url), UriKind.Absolute);
			else if (NavigationService.CanGoBack)
				NavigationService.GoBack(); //No image to show

			if (NavigationContext.QueryString.ContainsKey("ThumbUri"))
				thumburl = NavigationContext.QueryString["ThumbUri"];
			if (!string.IsNullOrEmpty(thumburl))
				datacontext.ThumbnailUri = new Uri(Uri.UnescapeDataString(thumburl), UriKind.Absolute);
			
			this.DataContext = datacontext;
		}

		private void ImageViewer_ImageOpened(object sender, EventArgs e)
		{
			progressBar.Visibility = Visibility.Collapsed;
		}

		private void ImageViewer_ImageFailed(object sender, EventArgs e)
		{
			MessageBox.Show("Failed to load image");
			if(NavigationService.CanGoBack)
				NavigationService.GoBack();
		}
	}
}